//
//  TextStatsViewController.m
//  Attrubitor
//
//  Created by Sameh Fakhouri on 10/5/15.
//  Copyright © 2015 Lehman College. All rights reserved.
//

#import "TextStatsViewController.h"

@interface TextStatsViewController ()
@property (weak, nonatomic) IBOutlet UILabel *colourfulCharactersLabel;
@property (weak, nonatomic) IBOutlet UILabel *outlineCharacterLabel;
@end

@implementation TextStatsViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    /*self.textToAnalyze = [[NSAttributedString alloc] initWithString:@"test" attributes:@{NSForegroundColorAttributeName:[UIColor greenColor],
                                                                                NSStrokeWidthAttributeName:@-3}];
*/
}



- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    [self updateUI];
}


- (void)setTextToAnalyze:(NSAttributedString *)textToAnalyze
{
    _textToAnalyze = textToAnalyze;
    if (self.view.window) {
        [self updateUI];
    }
}




- (void)updateUI
{
    int colourfulCharactersCount = (int) [[self charactersWithAttribute:NSForegroundColorAttributeName] length];
    self.colourfulCharactersLabel.text = [NSString stringWithFormat:@"%d Colorful Characters", colourfulCharactersCount];
    
    int outlinedCharactersCount = (int) [[self charactersWithAttribute:NSStrokeWidthAttributeName] length];
    self.outlineCharacterLabel.text = [NSString stringWithFormat:@"%d Outline Characters", outlinedCharactersCount];
}



- (NSAttributedString *)charactersWithAttribute: (NSString *)attributeName
{
    NSMutableAttributedString *characters = [[NSMutableAttributedString alloc] init];
    
    int index = 0;
    
    while (index < [self.textToAnalyze length]) {
        NSRange range;
        id value = [self.textToAnalyze attribute:attributeName
                                         atIndex:index
                                  effectiveRange:&range];
        if (value) {
            [characters appendAttributedString:[self.textToAnalyze attributedSubstringFromRange:range]];
            index = (int) (range.location + range.length);
        } else {
            index++;
        }
    }
    
    return characters;
}


@end
